diff --git a/pki/base/util/src/netscape/security/x509/BasicConstraintsExtension.java b/pki/base/util/src/netscape/security/x509/BasicConstraintsExtension.java
index 5846296d1ace936f870488d6957091c3e1aa9313..2688e961db1ad0c044574a2ca2ed82d60d0d5fd8 100644
--- a/pki/base/util/src/netscape/security/x509/BasicConstraintsExtension.java
+++ b/pki/base/util/src/netscape/security/x509/BasicConstraintsExtension.java
@@ -278,7 +278,7 @@ public class BasicConstraintsExtension extends Extension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(IS_CA);
         elements.addElement(PATH_LEN);
diff --git a/pki/base/util/src/netscape/security/x509/CRLDistributionPointsExtension.java b/pki/base/util/src/netscape/security/x509/CRLDistributionPointsExtension.java
index a15c1099f3a42cfd9ed6c196e1e7a8fc6056311b..c939a7431718d3d7fc5e5df02f2db034003cbbbd 100644
--- a/pki/base/util/src/netscape/security/x509/CRLDistributionPointsExtension.java
+++ b/pki/base/util/src/netscape/security/x509/CRLDistributionPointsExtension.java
@@ -227,8 +227,11 @@ public class CRLDistributionPointsExtension extends Extension
                 "CertAttrSet:CRLDistributionPointsExtension");
     }
 
-    public Enumeration getElements() {
-        return (new Vector()).elements();
+    /*
+     *	TODO use an empty collection to generate these
+     */
+    public Enumeration<String> getAttributeNames() {
+        return (new Vector<String>()).elements();
     }
 
     public String getName() {
diff --git a/pki/base/util/src/netscape/security/x509/CRLNumberExtension.java b/pki/base/util/src/netscape/security/x509/CRLNumberExtension.java
index e3965753c8c43131e537b76c3c718647a2a48234..7c89b179fe8c63054161768a0db18c341889f43e 100755
--- a/pki/base/util/src/netscape/security/x509/CRLNumberExtension.java
+++ b/pki/base/util/src/netscape/security/x509/CRLNumberExtension.java
@@ -211,7 +211,7 @@ public class CRLNumberExtension extends Extension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(NUMBER);
         return (elements.elements());
diff --git a/pki/base/util/src/netscape/security/x509/CRLReasonExtension.java b/pki/base/util/src/netscape/security/x509/CRLReasonExtension.java
index 22fbe894fe5e28abb2c2abbb8db9eb1305a6896c..3c11fc70bcc9c6195150fbd1aaef5f7ad2a5a4b7 100644
--- a/pki/base/util/src/netscape/security/x509/CRLReasonExtension.java
+++ b/pki/base/util/src/netscape/security/x509/CRLReasonExtension.java
@@ -207,7 +207,7 @@ public final class CRLReasonExtension extends Extension implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(REASON);
 
diff --git a/pki/base/util/src/netscape/security/x509/CertAttrSet.java b/pki/base/util/src/netscape/security/x509/CertAttrSet.java
index 9584326686faddb786cffab17aa71c9abd185681..7e8d6db82479ef728c31f2a37be51d7c56e61a4d 100755
--- a/pki/base/util/src/netscape/security/x509/CertAttrSet.java
+++ b/pki/base/util/src/netscape/security/x509/CertAttrSet.java
@@ -109,7 +109,7 @@ public interface CertAttrSet {
      * 
      * @return an enumeration of the attribute names.
      */
-    Enumeration getElements();
+    Enumeration<String> getAttributeNames();
 
     /**
      * Returns the name (identifier) of this CertAttrSet.
diff --git a/pki/base/util/src/netscape/security/x509/CertificateAlgorithmId.java b/pki/base/util/src/netscape/security/x509/CertificateAlgorithmId.java
index 1105dc4fdbcbb96fbc0d996a45bb94295f9fc0a7..41610844e8f02c8bcbdde6bd76b3cdebd7265a5b 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateAlgorithmId.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateAlgorithmId.java
@@ -174,7 +174,7 @@ public class CertificateAlgorithmId implements CertAttrSet, Serializable {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(ALGORITHM);
         return (elements.elements());
diff --git a/pki/base/util/src/netscape/security/x509/CertificateExtensions.java b/pki/base/util/src/netscape/security/x509/CertificateExtensions.java
index 7cd2b73c669df1a90111c4b34a56c179a21a7bc5..b9667d8f6a1f5ebb90e7dd8f5a3ee89accd9e4d7 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateExtensions.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateExtensions.java
@@ -43,7 +43,7 @@ import netscape.security.util.DerValue;
  * @version 1.11
  * @see CertAttrSet
  */
-public class CertificateExtensions extends Vector
+public class CertificateExtensions extends Vector<Extension>
         implements CertAttrSet, Serializable {
     /**
      *
@@ -59,12 +59,13 @@ public class CertificateExtensions extends Vector
      */
     public static final String NAME = "extensions";
 
-    private Hashtable<String, Object> map;
+    private Hashtable<String, Extension> map;
 
     // Parse the encoded extension
     public void parseExtension(Extension ext) throws IOException {
         try {
-            Class extClass = OIDMap.getClass(ext.getExtensionId());
+            @SuppressWarnings("unchecked")
+            Class<CertAttrSet> extClass = (Class<CertAttrSet>) OIDMap.getClass(ext.getExtensionId());
             if (extClass == null) { // Unsupported extension
                 if (ext.isCritical()) {
                     throw new IOException("Unsupported CRITICAL extension: "
@@ -75,8 +76,8 @@ public class CertificateExtensions extends Vector
                     return;
                 }
             }
-            Class[] params = { Boolean.class, Object.class };
-            Constructor cons = extClass.getConstructor(params);
+            Class<?>[] params = { Boolean.class, Object.class };
+            Constructor<CertAttrSet> cons = extClass.getConstructor(params);
 
             byte[] extData = ext.getExtensionValue();
             int extLen = extData.length;
@@ -87,7 +88,7 @@ public class CertificateExtensions extends Vector
             }
             Object[] passed = new Object[] { new Boolean(ext.isCritical()),
                     value };
-            CertAttrSet certExt = (CertAttrSet) cons.newInstance(passed);
+            CertAttrSet certExt = cons.newInstance(passed);
             if (certExt != null && certExt.getName() != null) {
                 map.put(certExt.getName(), (Extension) certExt);
                 addElement((Extension) certExt);
@@ -105,7 +106,7 @@ public class CertificateExtensions extends Vector
      * Default constructor for the certificate attribute.
      */
     public CertificateExtensions() {
-        map = new Hashtable();
+        map = new Hashtable<String, Extension>();
     }
 
     /**
@@ -117,7 +118,7 @@ public class CertificateExtensions extends Vector
     public CertificateExtensions(DerInputStream in)
             throws IOException {
 
-        map = new Hashtable();
+        map = new Hashtable<String, Extension>();
         DerValue[] exts = in.getSequence(5);
 
         for (int i = 0; i < exts.length; i++) {
@@ -136,7 +137,7 @@ public class CertificateExtensions extends Vector
         DerValue val = new DerValue(in);
         DerInputStream str = val.toDerInputStream();
 
-        map = new Hashtable();
+        map = new Hashtable<String, Extension>();
         DerValue[] exts = str.getSequence(5);
 
         for (int i = 0; i < exts.length; i++) {
@@ -160,7 +161,7 @@ public class CertificateExtensions extends Vector
             str = val.toDerInputStream();
         }
 
-        map = new Hashtable();
+        map = new Hashtable<String, Extension>();
         DerValue[] exts = str.getSequence(5);
 
         for (int i = 0; i < exts.length; i++) {
@@ -217,8 +218,8 @@ public class CertificateExtensions extends Vector
      * @exception IOException if the object could not be cached.
      */
     public void set(String name, Object obj) throws IOException {
-        map.put(name, obj);
-        addElement(obj);
+        map.put(name, (Extension) obj);
+        addElement((Extension) obj);
     }
 
     /**
@@ -250,7 +251,7 @@ public class CertificateExtensions extends Vector
         removeElement(obj);
     }
 
-    public Enumeration getNames() {
+    public Enumeration<String> getNames() {
         return map.keys();
     }
 
@@ -258,10 +259,14 @@ public class CertificateExtensions extends Vector
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration getElements() {
+    public Enumeration<Extension> getAttributes() {
         return (map.elements());
     }
 
+    public Enumeration<String> getAttributeNames() {
+        return (map.keys());
+    }
+
     /**
      * Return the name of this attribute.
      */
diff --git a/pki/base/util/src/netscape/security/x509/CertificateIssuerExtension.java b/pki/base/util/src/netscape/security/x509/CertificateIssuerExtension.java
index 490c087bb297eba75ebd3a2d6c720d8e02990f37..774116bcc16ce825132c57d3d19816395601e3cf 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateIssuerExtension.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateIssuerExtension.java
@@ -226,7 +226,7 @@ public class CertificateIssuerExtension extends Extension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(CERTIFICATE_ISSUER);
 
diff --git a/pki/base/util/src/netscape/security/x509/CertificateIssuerName.java b/pki/base/util/src/netscape/security/x509/CertificateIssuerName.java
index 83bea856c638e023b1057062108871d0889e9fbb..a2f9026c197d07c075df1432024f4efdb1eb6384 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateIssuerName.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateIssuerName.java
@@ -156,7 +156,7 @@ public class CertificateIssuerName implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(DN_NAME);
 
diff --git a/pki/base/util/src/netscape/security/x509/CertificateIssuerUniqueIdentity.java b/pki/base/util/src/netscape/security/x509/CertificateIssuerUniqueIdentity.java
index f54b1e0b939a2c1d8b8d01041fb5330a354a1d6f..351116ffbcaae80364abd137d74ee257e2b3ab4f 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateIssuerUniqueIdentity.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateIssuerUniqueIdentity.java
@@ -169,7 +169,7 @@ public class CertificateIssuerUniqueIdentity implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(ID);
 
diff --git a/pki/base/util/src/netscape/security/x509/CertificateSerialNumber.java b/pki/base/util/src/netscape/security/x509/CertificateSerialNumber.java
index de1e794d56ee165c4182038c7e0c6181c3342551..e9655178f4c4733c427ea7018cefed6a1d352ef2 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateSerialNumber.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateSerialNumber.java
@@ -175,7 +175,7 @@ public class CertificateSerialNumber implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(NUMBER);
 
diff --git a/pki/base/util/src/netscape/security/x509/CertificateSubjectName.java b/pki/base/util/src/netscape/security/x509/CertificateSubjectName.java
index 227dc41e1fd8891b8ee590a3b905bfca12a7615b..6159638b9843d2c4040b115b0c0f5623502a5f56 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateSubjectName.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateSubjectName.java
@@ -187,7 +187,7 @@ public class CertificateSubjectName implements CertAttrSet, Serializable {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(DN_NAME);
 
diff --git a/pki/base/util/src/netscape/security/x509/CertificateSubjectUniqueIdentity.java b/pki/base/util/src/netscape/security/x509/CertificateSubjectUniqueIdentity.java
index c8e06fb385b56691f30d9bdfdff3d185b1d18ce3..51687e86dddfdf6ba43291dad649f2e8c3ca2f00 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateSubjectUniqueIdentity.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateSubjectUniqueIdentity.java
@@ -169,7 +169,7 @@ public class CertificateSubjectUniqueIdentity implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(ID);
 
diff --git a/pki/base/util/src/netscape/security/x509/CertificateValidity.java b/pki/base/util/src/netscape/security/x509/CertificateValidity.java
index c54da58b254ad6bf4a1129176b4986e5706e0ace..0c2c841b020955db59e4e5672ff9208355e5b87b 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateValidity.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateValidity.java
@@ -247,7 +247,7 @@ public class CertificateValidity implements CertAttrSet, Serializable {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(NOT_BEFORE);
         elements.addElement(NOT_AFTER);
diff --git a/pki/base/util/src/netscape/security/x509/CertificateVersion.java b/pki/base/util/src/netscape/security/x509/CertificateVersion.java
index 9b976e2028e58d1d2165b1f2a29985bdbc22f9dd..d3659779f8398bb254048b03b698cc3636aca78c 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateVersion.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateVersion.java
@@ -224,7 +224,7 @@ public class CertificateVersion implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(VERSION);
 
diff --git a/pki/base/util/src/netscape/security/x509/CertificateX509Key.java b/pki/base/util/src/netscape/security/x509/CertificateX509Key.java
index 58c18f084c5d542cf90d102da9ddc236bc0eb2a4..c7003bb8ef5c2cd1e19f9a958b139e5ff24b6b94 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateX509Key.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateX509Key.java
@@ -174,7 +174,7 @@ public class CertificateX509Key implements CertAttrSet, Serializable {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(KEY);
 
diff --git a/pki/base/util/src/netscape/security/x509/DeltaCRLIndicatorExtension.java b/pki/base/util/src/netscape/security/x509/DeltaCRLIndicatorExtension.java
index 6e8f9fa0242014d3ee8894b55b3ecd59d65ede64..da870f4fdf15a9213d083ab25b8b23a0c538301e 100755
--- a/pki/base/util/src/netscape/security/x509/DeltaCRLIndicatorExtension.java
+++ b/pki/base/util/src/netscape/security/x509/DeltaCRLIndicatorExtension.java
@@ -224,7 +224,7 @@ public class DeltaCRLIndicatorExtension extends Extension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(NUMBER);
         return (elements.elements());
diff --git a/pki/base/util/src/netscape/security/x509/Extensions.java b/pki/base/util/src/netscape/security/x509/Extensions.java
index 63856300ee39d5b09d67742f3a821d085417c6a1..622367ab606fedd69aaba84c911cedb0170eadc8 100644
--- a/pki/base/util/src/netscape/security/x509/Extensions.java
+++ b/pki/base/util/src/netscape/security/x509/Extensions.java
@@ -40,7 +40,7 @@ import netscape.security.util.DerValue;
  * @version 1.11
  * @see CertAttrSet
  */
-public class Extensions extends Vector
+public class Extensions extends Vector<Extension>
         implements CertAttrSet {
     /**
      *
@@ -56,12 +56,13 @@ public class Extensions extends Vector
      */
     public static final String NAME = "extensions";
 
-    private Hashtable map;
+    private Hashtable<String, Extension> map;
 
     // Parse the encoded extension
     public void parseExtension(Extension ext) throws IOException {
         try {
-            Class extClass = OIDMap.getClass(ext.getExtensionId());
+            @SuppressWarnings("unchecked")
+            Class<CertAttrSet> extClass = (Class<CertAttrSet>) OIDMap.getClass(ext.getExtensionId());
             if (extClass == null) { // Unsupported extension
                 if (ext.isCritical()) {
                     throw new IOException("Unsupported CRITICAL extension: "
@@ -72,8 +73,8 @@ public class Extensions extends Vector
                     return;
                 }
             }
-            Class[] params = { Boolean.class, Object.class };
-            Constructor cons = extClass.getConstructor(params);
+            Class<?>[] params = { Boolean.class, Object.class };
+            Constructor<CertAttrSet> cons = extClass.getConstructor(params);
 
             byte[] extData = ext.getExtensionValue();
             int extLen = extData.length;
@@ -84,9 +85,9 @@ public class Extensions extends Vector
             }
             Object[] passed = new Object[] { new Boolean(ext.isCritical()),
                                                         value };
-            CertAttrSet certExt = (CertAttrSet) cons.newInstance(passed);
-            map.put(certExt.getName(), certExt);
-            addElement(certExt);
+            CertAttrSet certExt = cons.newInstance(passed);
+            map.put(certExt.getName(), (Extension) certExt);
+            addElement((Extension) certExt);
 
         } catch (NoSuchMethodException nosuch) {
             throw new IOException(nosuch.toString());
@@ -101,7 +102,7 @@ public class Extensions extends Vector
      * Default constructor for the certificate attribute.
      */
     public Extensions() {
-        map = new Hashtable();
+        map = new Hashtable<String, Extension>();
     }
 
     /**
@@ -113,7 +114,7 @@ public class Extensions extends Vector
     public Extensions(DerInputStream in)
             throws IOException {
 
-        map = new Hashtable();
+        map = new Hashtable<String, Extension>();
         DerValue[] exts = in.getSequence(5);
 
         for (int i = 0; i < exts.length; i++) {
@@ -132,7 +133,7 @@ public class Extensions extends Vector
         DerValue val = new DerValue(in);
         DerInputStream str = val.toDerInputStream();
 
-        map = new Hashtable();
+        map = new Hashtable<String, Extension>();
         DerValue[] exts = str.getSequence(5);
 
         for (int i = 0; i < exts.length; i++) {
@@ -175,8 +176,8 @@ public class Extensions extends Vector
      * @exception IOException if the object could not be cached.
      */
     public void set(String name, Object obj) throws IOException {
-        map.put(name, obj);
-        addElement(obj);
+        map.put(name, (Extension) obj);
+        addElement((Extension) obj);
     }
 
     /**
@@ -212,8 +213,8 @@ public class Extensions extends Vector
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration getElements() {
-        return (map.elements());
+    public Enumeration<String> getAttributeNames() {
+        return map.keys();
     }
 
     /**
diff --git a/pki/base/util/src/netscape/security/x509/FreshestCRLExtension.java b/pki/base/util/src/netscape/security/x509/FreshestCRLExtension.java
index 5d7bd50b690370b0f1a207238f9fb3c37a391665..320bbf3df24df42461626b833fc820091ec9baa7 100644
--- a/pki/base/util/src/netscape/security/x509/FreshestCRLExtension.java
+++ b/pki/base/util/src/netscape/security/x509/FreshestCRLExtension.java
@@ -233,8 +233,11 @@ public class FreshestCRLExtension extends Extension
                 "CertAttrSet:FreshestCRLExtension");
     }
 
-    public Enumeration getElements() {
-        return (new Vector()).elements();
+    /*
+     * TODO replacewith empty collection
+     */
+    public Enumeration<String> getAttributeNames() {
+        return (new Vector<String>()).elements();
     }
 
     public String getName() {
diff --git a/pki/base/util/src/netscape/security/x509/HoldInstructionExtension.java b/pki/base/util/src/netscape/security/x509/HoldInstructionExtension.java
index 80324f8d891c16cbc6175b12d19e61c7bc3c663d..b42bb6ac91268ea49d6d2cc1790508d3a858599a 100644
--- a/pki/base/util/src/netscape/security/x509/HoldInstructionExtension.java
+++ b/pki/base/util/src/netscape/security/x509/HoldInstructionExtension.java
@@ -339,7 +339,7 @@ public class HoldInstructionExtension extends Extension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(HOLD_INSTRUCTION);
         return (elements.elements());
diff --git a/pki/base/util/src/netscape/security/x509/InvalidityDateExtension.java b/pki/base/util/src/netscape/security/x509/InvalidityDateExtension.java
index 73e76087fccfa1c1a4620bb292af86c8dbd02e49..44c76275f17179bcb129982b1c7202f7c6445308 100755
--- a/pki/base/util/src/netscape/security/x509/InvalidityDateExtension.java
+++ b/pki/base/util/src/netscape/security/x509/InvalidityDateExtension.java
@@ -226,7 +226,7 @@ public class InvalidityDateExtension extends Extension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(INVALIDITY_DATE);
         return (elements.elements());
diff --git a/pki/base/util/src/netscape/security/x509/IssuerAlternativeNameExtension.java b/pki/base/util/src/netscape/security/x509/IssuerAlternativeNameExtension.java
index a21d3ac3254a6b0ae5ccc690b3e6137c9c1d194e..df0289f9e008fc059d4bf67dda055df3513e9fe0 100644
--- a/pki/base/util/src/netscape/security/x509/IssuerAlternativeNameExtension.java
+++ b/pki/base/util/src/netscape/security/x509/IssuerAlternativeNameExtension.java
@@ -224,7 +224,7 @@ public class IssuerAlternativeNameExtension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(ISSUER_NAME);
 
diff --git a/pki/base/util/src/netscape/security/x509/IssuingDistributionPointExtension.java b/pki/base/util/src/netscape/security/x509/IssuingDistributionPointExtension.java
index 9eb9d14a9d21ef48aa80d0bfed29c7b13ede8a48..fc7e837ce9d5b30e131fe0d315cf81c5d01c7783 100644
--- a/pki/base/util/src/netscape/security/x509/IssuingDistributionPointExtension.java
+++ b/pki/base/util/src/netscape/security/x509/IssuingDistributionPointExtension.java
@@ -340,7 +340,7 @@ public class IssuingDistributionPointExtension extends Extension
         }
     }
 
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(ISSUING_DISTRIBUTION_POINT);
         return (elements.elements());
diff --git a/pki/base/util/src/netscape/security/x509/KeyUsageExtension.java b/pki/base/util/src/netscape/security/x509/KeyUsageExtension.java
index 043208806f993bbfa6eb767ca16858cb88028b38..56084dbcfd7d83fbc98280af441bda39b22c0ecd 100644
--- a/pki/base/util/src/netscape/security/x509/KeyUsageExtension.java
+++ b/pki/base/util/src/netscape/security/x509/KeyUsageExtension.java
@@ -386,7 +386,7 @@ public class KeyUsageExtension extends Extension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(DIGITAL_SIGNATURE);
         elements.addElement(NON_REPUDIATION);
diff --git a/pki/base/util/src/netscape/security/x509/NSCCommentExtension.java b/pki/base/util/src/netscape/security/x509/NSCCommentExtension.java
index 5ac3357cec9bde2fcda8f6e96fc3055214dbb26b..b24ce1158881ee68bc41e6cc9de9b23f9dae4af4 100644
--- a/pki/base/util/src/netscape/security/x509/NSCCommentExtension.java
+++ b/pki/base/util/src/netscape/security/x509/NSCCommentExtension.java
@@ -58,7 +58,7 @@ public class NSCCommentExtension extends Extension
     public String mComment = null;
 
     // Private data members 
-    private Vector mInfos;
+    private Vector<Object> mInfos;
 
     private PrettyPrintFormat pp = new PrettyPrintFormat(":");
 
@@ -90,7 +90,7 @@ public class NSCCommentExtension extends Extension
     public NSCCommentExtension(boolean critical) {
         this.extensionId = new ObjectIdentifier("2.16.840.1.113730.1.13");
         this.critical = critical;
-        mInfos = new Vector(1, 1);
+        mInfos = new Vector<Object>(1, 1);
     }
 
     /**
@@ -171,6 +171,7 @@ public class NSCCommentExtension extends Extension
     /**
      * Set the attribute value.
      */
+    @SuppressWarnings("unchecked")
     public void set(String name, Object obj) throws IOException {
         clearValue();
         if (name.equalsIgnoreCase(INFOS)) {
@@ -178,7 +179,7 @@ public class NSCCommentExtension extends Extension
                 throw new IOException("Attribute value should be of" +
                                     " type Vector.");
             }
-            mInfos = (Vector) obj;
+            mInfos = (Vector<Object>) obj;
         } else {
             throw new IOException("Attribute name not recognized by " +
                         "CertAttrSet:NSCCommentExtension.");
@@ -213,9 +214,9 @@ public class NSCCommentExtension extends Extension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration getElements() {
-        Vector elements = new Vector();
-        elements.addElement(mInfos);
+    public Enumeration<String> getAttributeNames() {
+        Vector<String> elements = new Vector<String>();
+        elements.addElement(INFOS);
         return (elements.elements());
     }
 
diff --git a/pki/base/util/src/netscape/security/x509/NameConstraintsExtension.java b/pki/base/util/src/netscape/security/x509/NameConstraintsExtension.java
index d3ca8c11625b41fad0a834b533fa19cc044624e3..948d0d8c9f519c39a6d26806a2a02bdcfa3bee67 100644
--- a/pki/base/util/src/netscape/security/x509/NameConstraintsExtension.java
+++ b/pki/base/util/src/netscape/security/x509/NameConstraintsExtension.java
@@ -298,7 +298,7 @@ public class NameConstraintsExtension extends Extension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(PERMITTED_SUBTREES);
         elements.addElement(EXCLUDED_SUBTREES);
diff --git a/pki/base/util/src/netscape/security/x509/PolicyConstraintsExtension.java b/pki/base/util/src/netscape/security/x509/PolicyConstraintsExtension.java
index 194903dd590c6b4ebe5861f0ec4296ed31185dcc..7d98b21ba5c68dca2ba825524bd72a9d744ddfcc 100644
--- a/pki/base/util/src/netscape/security/x509/PolicyConstraintsExtension.java
+++ b/pki/base/util/src/netscape/security/x509/PolicyConstraintsExtension.java
@@ -275,7 +275,7 @@ public class PolicyConstraintsExtension extends Extension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(REQUIRE);
         elements.addElement(INHIBIT);
diff --git a/pki/base/util/src/netscape/security/x509/PolicyMappingsExtension.java b/pki/base/util/src/netscape/security/x509/PolicyMappingsExtension.java
index 6f2e583bca216ada928131e6526ca60584ec2d3d..9bdfb611bd07edfb41120aa1f00eeb18df83b3fa 100644
--- a/pki/base/util/src/netscape/security/x509/PolicyMappingsExtension.java
+++ b/pki/base/util/src/netscape/security/x509/PolicyMappingsExtension.java
@@ -190,6 +190,7 @@ public class PolicyMappingsExtension extends Extension
     /**
      * Set the attribute value.
      */
+    @SuppressWarnings("unchecked")
     public void set(String name, Object obj) throws IOException {
         clearValue();
         if (name.equalsIgnoreCase(MAP)) {
@@ -232,7 +233,7 @@ public class PolicyMappingsExtension extends Extension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(MAP);
 
